''
''
'' enet -- header translated with help of SWIG FB wrapper
''
'' NOTICE: This file is part of the FreeBASIC Compiler package and can't
''         be included in other distributions without authorization.
''
''
#ifndef __enet_bi__
#define __enet_bi__



#Include once "crt/stdlib.bi"

#include once "enet/types.bi"
#include once "enet/protocol.bi"
#include once "enet/list.bi"
#include Once "enet/callbacks.bi"

#Ifdef __FB_WIN32__
	#Ifdef ENET_DLL
		#Inclib "enet.dll"
	#Else
		#Inclib "winmm"
		#Inclib "enet_static"
	#EndIf

	#Include once "enet/win32.bi"
#EndIf

#Ifdef __FB_LINUX__
	#Inclib "enet"
	#Include once "enet/unix.bi"
#EndIf


TYPE  ENetPeer AS _ENetPeer
TYPE  ENetHost AS _ENetHost

Enum ENetVersion
   ENET_VERSION = 1
End Enum

enum ENetSocketType
	ENET_SOCKET_TYPE_STREAM = 1
	ENET_SOCKET_TYPE_DATAGRAM = 2
end enum


enum ENetSocketWait
	ENET_SOCKET_WAIT_NONE = 0
	ENET_SOCKET_WAIT_SEND = (1 shl 0)
	ENET_SOCKET_WAIT_RECEIVE = (1 shl 1)
end enum

enum 
	ENET_HOST_ANY = 0
end enum

type ENetAddress
	host as enet_uint32
	port as enet_uint16
end type

enum ENetPacketFlag
	ENET_PACKET_FLAG_UNRELIABLE
	ENET_PACKET_FLAG_RELIABLE = (1 shl 0)
	ENET_PACKET_FLAG_NO_ALLOCATE = (1 shl 2)
end enum

type _ENetPacket As ENetPacket
Type ENetPacketFreeCallback As Sub(byval as _ENetPacket ptr)

type ENetPacket
	referenceCount as size_t
	flags as enet_uint32
	data as enet_uint8 ptr
	dataLength as size_t
	freeCallback As ENetPacketFreeCallback
end type


type ENetAcknowledgement
	acknowledgementList as ENetListNode
	sentTime as enet_uint32
	command as ENetProtocol
end type

type ENetOutgoingCommand
	outgoingCommandList as ENetListNode
	reliableSequenceNumber as enet_uint16
	unreliableSequenceNumber as enet_uint16
	sentTime as enet_uint32
	roundTripTimeout as enet_uint32
	roundTripTimeoutLimit as enet_uint32
	fragmentOffset as enet_uint32
	fragmentLength as enet_uint16
	command as ENetProtocol
	packet as ENetPacket ptr
end type



type ENetIncomingCommand
	incomingCommandList as ENetListNode
	reliableSequenceNumber as enet_uint16
	unreliableSequenceNumber as enet_uint16
	command as ENetProtocol
	fragmentCount as enet_uint32
	fragmentsRemaining as enet_uint32
	fragments as enet_uint32 ptr
	packet as ENetPacket ptr
end type


enum ENetPeerState
   ENET_PEER_STATE_DISCONNECTED                = 0
   ENET_PEER_STATE_CONNECTING                  = 1
   ENET_PEER_STATE_ACKNOWLEDGING_CONNECT       = 2
   ENET_PEER_STATE_CONNECTION_PENDING          = 3
   ENET_PEER_STATE_CONNECTION_SUCCEEDED        = 4
   ENET_PEER_STATE_CONNECTED                   = 5
   ENET_PEER_STATE_DISCONNECT_LATER            = 6
   ENET_PEER_STATE_DISCONNECTING               = 7
   ENET_PEER_STATE_ACKNOWLEDGING_DISCONNECT    = 8
   ENET_PEER_STATE_ZOMBIE                      = 9 
end enum


enum 
   ENET_HOST_RECEIVE_BUFFER_SIZE          = 256 * 1024
   ENET_HOST_SEND_BUFFER_SIZE             = 256 * 1024
   ENET_HOST_BANDWIDTH_THROTTLE_INTERVAL  = 1000
   ENET_HOST_DEFAULT_MTU                  = 1400

   ENET_PEER_DEFAULT_ROUND_TRIP_TIME      = 500
   ENET_PEER_DEFAULT_PACKET_THROTTLE      = 32
   ENET_PEER_PACKET_THROTTLE_SCALE        = 32
   ENET_PEER_PACKET_THROTTLE_COUNTER      = 7
   ENET_PEER_PACKET_THROTTLE_ACCELERATION = 2
   ENET_PEER_PACKET_THROTTLE_DECELERATION = 2
   ENET_PEER_PACKET_THROTTLE_INTERVAL     = 5000
   ENET_PEER_PACKET_LOSS_SCALE            = (1 shl 16)
   ENET_PEER_PACKET_LOSS_INTERVAL         = 10000
   ENET_PEER_WINDOW_SIZE_SCALE            = 64 * 1024
   ENET_PEER_TIMEOUT_LIMIT                = 32
   ENET_PEER_TIMEOUT_MINIMUM              = 35000
   ENET_PEER_TIMEOUT_MAXIMUM              = 30000
   ENET_PEER_PING_INTERVAL                = 500
   ENET_PEER_UNSEQUENCED_WINDOW_SIZE      = 4 * 32
end enum

type ENetChannel
	outgoingReliableSequenceNumber as enet_uint16
	outgoingUnreliableSequenceNumber as enet_uint16
	incomingReliableSequenceNumber as enet_uint16
	incomingUnreliableSequenceNumber as enet_uint16
	incomingReliableCommands as ENetList
	incomingUnreliableCommands as ENetList
end type


type _ENetPeer
	host as ENetHost ptr
	outgoingPeerID as enet_uint16
	incomingPeerID as enet_uint16
	sessionID as enet_uint32
	address as ENetAddress
	data as any ptr
	state as ENetPeerState
	channels as ENetChannel ptr
	channelCount as size_t
	incomingBandwidth as enet_uint32
	outgoingBandwidth as enet_uint32
	incomingBandwidthThrottleEpoch as enet_uint32
	outgoingBandwidthThrottleEpoch as enet_uint32
	incomingDataTotal as enet_uint32
	outgoingDataTotal as enet_uint32
	lastSendTime as enet_uint32
	lastReceiveTime as enet_uint32
	nextTimeout as enet_uint32
   earliestTimeout As enet_uint32
	packetLossEpoch as enet_uint32
	packetsSent as enet_uint32
	packetsLost as enet_uint32
	packetLoss as enet_uint32
	packetLossVariance as enet_uint32
	packetThrottle as enet_uint32
	packetThrottleLimit as enet_uint32
	packetThrottleCounter as enet_uint32
	packetThrottleEpoch as enet_uint32
	packetThrottleAcceleration as enet_uint32
	packetThrottleDeceleration as enet_uint32
	packetThrottleInterval as enet_uint32
	lastRoundTripTime as enet_uint32
	lowestRoundTripTime as enet_uint32
	lastRoundTripTimeVariance as enet_uint32
	highestRoundTripTimeVariance as enet_uint32
	roundTripTime as enet_uint32
	roundTripTimeVariance as enet_uint32
	mtu as enet_uint16
	windowSize as enet_uint32
	reliableDataInTransit as enet_uint32
	outgoingReliableSequenceNumber as enet_uint16
	acknowledgements as ENetList
	sentReliableCommands as ENetList
	sentUnreliableCommands as ENetList
	outgoingReliableCommands as ENetList
	outgoingUnreliableCommands as ENetList
   incomingUnsequencedGroup as enet_uint16
   outgoingUnsequencedGroup as enet_uint16
   unsequencedWindow(ENET_PEER_UNSEQUENCED_WINDOW_SIZE / 32) As enet_uint32	
	disconnectData as enet_uint32   
End type


type _ENetHost
	socket as ENetSocket
	address as ENetAddress
	incomingBandwidth as enet_uint32
	outgoingBandwidth as enet_uint32
	bandwidthThrottleEpoch as enet_uint32
	mtu as enet_uint32
	recalculateBandwidthLimits as integer
	peers as ENetPeer ptr
	peerCount as size_t
	lastServicedPeer as ENetPeer ptr
	continueSending As integer
	packetSize as size_t
	headerFlags As enet_uint16
	commands(0 to ENET_PROTOCOL_MAXIMUM_PACKET_COMMANDS-1) as ENetProtocol
	commandCount as size_t
	buffers(0 to (1+2*ENET_PROTOCOL_MAXIMUM_PACKET_COMMANDS)-1) as ENetBuffer
	bufferCount as size_t
	receivedAddress as ENetAddress
	receivedData(0 to ENET_PROTOCOL_MAXIMUM_MTU-1) as enet_uint8
	receivedDataLength as size_t
end type


enum ENetEventType
	ENET_EVENT_TYPE_NONE = 0
	ENET_EVENT_TYPE_CONNECT = 1
	ENET_EVENT_TYPE_DISCONNECT = 2
	ENET_EVENT_TYPE_RECEIVE = 3
end enum

type ENetEvent
	type as ENetEventType
	peer as ENetPeer ptr
	channelID as enet_uint8
	data as enet_uint32
	packet as ENetPacket ptr
end type

Extern "C"

Declare function enet_initialize Cdecl alias "enet_initialize" () as integer
Declare function enet_initialize_with_callbacks Cdecl alias "enet_initialize_with_callbacks"(byval as ENetVersion, ByVal As ENetCallbacks ptr) As integer
Declare sub enet_deinitialize Cdecl alias "enet_deinitialize" ()

Declare function enet_time_get Cdecl alias "enet_time_get" () as enet_uint32
declare sub enet_time_set Cdecl alias "enet_time_set" (byval as enet_uint32)

Declare function enet_socket_create Cdecl alias "enet_socket_create" (byval as ENetSocketType, byval as ENetAddress ptr) as ENetSocket
declare function enet_socket_accept Cdecl alias "enet_socket_accept" (byval as ENetSocket, byval as ENetAddress ptr) as ENetSocket
declare function enet_socket_connect Cdecl alias "enet_socket_connect" (byval as ENetSocket, byval as ENetAddress ptr) as integer
declare function enet_socket_send Cdecl alias "enet_socket_send" (byval as ENetSocket, byval as ENetAddress ptr, byval as ENetBuffer ptr, byval as size_t) as integer
declare function enet_socket_receive Cdecl alias "enet_socket_receive" (byval as ENetSocket, byval as ENetAddress ptr, byval as ENetBuffer ptr, byval as size_t) as integer
declare function enet_socket_wait Cdecl alias "enet_socket_wait" (byval as ENetSocket, byval as enet_uint32 ptr, byval as enet_uint32) as integer
declare sub enet_socket_destroy Cdecl alias "enet_socket_destroy" (byval as ENetSocket)

Declare function enet_address_set_host Cdecl alias "enet_address_set_host" (byval address as ENetAddress ptr, byval hostName as zstring ptr) as integer
declare function enet_address_get_host_ip (byval address as ENetAddress ptr, byval hostName As zstring ptr, byval nameLength As size_t) As integer
Declare function enet_address_get_host Cdecl alias "enet_address_get_host" (byval address as ENetAddress ptr, byval hostName as zstring ptr, byval nameLength as size_t) as integer

Declare function enet_packet_create Cdecl alias "enet_packet_create" (byval dataContents as any ptr, byval dataLength as size_t, byval flags as enet_uint32) as ENetPacket ptr
declare sub enet_packet_destroy Cdecl alias "enet_packet_destroy" (byval packet as ENetPacket ptr)
declare function enet_packet_resize Cdecl alias "enet_packet_resize" (byval packet as ENetPacket ptr, byval dataLength as size_t) as integer
declare function enet_crc32 Cdecl alias "enet_crc32"(byval as ENetBuffer ptr , byval as size_t) As enet_uint32

Declare function enet_host_create Cdecl alias "enet_host_create" (byval address as ENetAddress ptr, byval peerCount as size_t, byval incomingBandwidth as enet_uint32, byval outgoingBandwidth as enet_uint32) as ENetHost ptr
Declare sub enet_host_destroy Cdecl alias "enet_host_destroy" (byval host as ENetHost ptr)
declare function enet_host_connect Cdecl alias "enet_host_connect" (byval host as ENetHost ptr, byval address as ENetAddress ptr, byval channelCount as size_t) as ENetPeer ptr
declare function enet_host_service Cdecl alias "enet_host_service" (ByVal host as ENetHost ptr, byval event as ENetEvent ptr, byval timeout as enet_uint32) as integer
declare sub enet_host_flush Cdecl alias "enet_host_flush" (byval as ENetHost ptr)
declare sub enet_host_broadcast Cdecl alias "enet_host_broadcast" (byval as ENetHost ptr, byval as enet_uint8, byval as ENetPacket ptr)
declare sub enet_host_bandwidth_limit Cdecl alias "enet_host_bandwidth_limit" (byval as ENetHost ptr, byval as enet_uint32, byval as enet_uint32)
declare sub enet_host_bandwidth_throttle Cdecl alias "enet_host_bandwidth_throttle" (byval as ENetHost ptr)

Declare function enet_peer_send Cdecl alias "enet_peer_send" (byval as ENetPeer ptr, byval as enet_uint8, byval as ENetPacket ptr) as integer
declare function enet_peer_receive Cdecl alias "enet_peer_receive" (byval as ENetPeer ptr, byval as enet_uint8) as ENetPacket ptr
declare sub enet_peer_ping Cdecl alias "enet_peer_ping" (byval as ENetPeer ptr)
declare sub enet_peer_reset Cdecl alias "enet_peer_reset" (byval as ENetPeer ptr)
declare sub enet_peer_disconnect Cdecl alias "enet_peer_disconnect" (byval as ENetPeer ptr, ByVal As enet_uint32)
declare sub enet_peer_disconnect_now Cdecl alias "enet_peer_disconnect_now" (byval as ENetPeer ptr, ByVal As enet_uint32)
declare sub enet_peer_disconnect_later Cdecl alias "enet_peer_disconnect_later" (byval as ENetPeer ptr, ByVal As enet_uint32)
Declare sub enet_peer_throttle_configure Cdecl alias "enet_peer_throttle_configure" (byval as ENetPeer ptr, byval as enet_uint32, byval as enet_uint32, byval as enet_uint32)
declare function enet_peer_throttle Cdecl alias "enet_peer_throttle" (byval as ENetPeer ptr, byval as enet_uint32) as integer
declare sub enet_peer_reset_queues Cdecl alias "enet_peer_reset_queues" (byval as ENetPeer ptr)
declare function enet_peer_queue_outgoing_command Cdecl alias "enet_peer_queue_outgoing_command" (byval as ENetPeer ptr, byval as ENetProtocol ptr, byval as ENetPacket ptr, byval as enet_uint32, byval as enet_uint16) as ENetOutgoingCommand ptr
declare function enet_peer_queue_incoming_command Cdecl alias "enet_peer_queue_incoming_command" (byval as ENetPeer ptr, byval as ENetProtocol ptr, byval as ENetPacket ptr, byval as enet_uint32) as ENetIncomingCommand ptr
declare function enet_peer_queue_acknowledgement Cdecl alias "enet_peer_queue_acknowledgement" (byval as ENetPeer ptr, byval as ENetProtocol ptr, byval as enet_uint32) as ENetAcknowledgement ptr


End extern
#endif
