'** 
' @file  unix.h
' @brief ENet Unix header
'**
#ifndef __ENET_UNIX_H__
#define __ENET_UNIX_H__

#include once "crt/stdlib.bi"
#include once "crt/sys/types.bi"
#include once "crt/netinet/in.bi"


Type ENetSocket As integer

enum

    ENET_SOCKET_NULL = -1

End enum

#define ENET_HOST_TO_NET_16(value) (htons (value))' /**< macro that converts host to net byte-order of a 16-bit value */
#define ENET_HOST_TO_NET_32(value) (htonl (value))' /**< macro that converts host to net byte-order of a 32-bit value */

#define ENET_NET_TO_HOST_16(value) (ntohs (value))' /**< macro that converts net to host byte-order of a 16-bit value */
#define ENET_NET_TO_HOST_32(value) (ntohl (value))' /**< macro that converts net to host byte-order of a 32-bit value */

Type ENetBuffer
    Data As Any ptr
    dataLength as size_t
End type

#define ENET_CALLBACK

'#Define ENET_API extern

#endif '* __ENET_UNIX_H__ *
